blob: 5a858c36acb03930a28925ec4f9f462f5950fba5 [file] [log] [blame]
Zack Williamse940c7a2019-08-21 14:25:39 -07001help:
David Bainbridgec4029aa2019-09-26 18:56:39 +00002 @echo "release - build binaries using cross compliing for the support architectures"
3 @echo "build - build the binary as a local executable"
4 @echo "install - build and install the binary into \$$GOPATH/bin"
5 @echo "run - runs voltctl using the command specified as \$$CMD"
David Bainbridge12f036f2019-10-15 22:09:04 +00006 @echo "lint-style - Verify code is properly gofmt-ed"
7 @echo "lint-sanity - Verify that 'go vet' doesn't report any issues"
8 @echo "lint-mod - Verify the integrity of the 'mod' files"
David Bainbridge86971522019-09-26 22:09:39 +00009 @echo "lint - run static code analysis"
David Bainbridge12f036f2019-10-15 22:09:04 +000010 @echo "sca - Runs various SCA through golangci-lint tool"
David Bainbridge86971522019-09-26 22:09:39 +000011 @echo "test - run unity tests"
David Bainbridge12f036f2019-10-15 22:09:04 +000012 @echo "check - runs targets that should be run before a commit"
David Bainbridgec4029aa2019-09-26 18:56:39 +000013 @echo "clean - remove temporary and generated files"
Zack Williamse940c7a2019-08-21 14:25:39 -070014
David Bainbridge12f036f2019-10-15 22:09:04 +000015SHELL=bash -e -o pipefail
16
David Bainbridge86971522019-09-26 22:09:39 +000017VERSION=$(shell cat ./VERSION)
Zack Williamse940c7a2019-08-21 14:25:39 -070018GITCOMMIT=$(shell git rev-parse HEAD)
19ifeq ($(shell git ls-files --others --modified --exclude-standard 2>/dev/null | wc -l | sed -e 's/ //g'),0)
20GITDIRTY=false
21else
22GITDIRTY=true
23endif
24GOVERSION=$(shell go version 2>&1 | sed -E 's/.*(go[0-9]+\.[0-9]+\.[0-9]+).*/\1/g')
25HOST_OS=$(shell uname -s | tr A-Z a-z)
26ifeq ($(shell uname -m),x86_64)
27 HOST_ARCH ?= amd64
28else
29 HOST_ARCH ?= $(shell uname -m)
30endif
31BUILDTIME=$(shell date -u +"%Y-%m-%dT%H:%M:%SZ")
32
33LDFLAGS=-ldflags \
Kent Hagerman813cb902020-02-20 10:01:38 -050034 "-X \"github.com/opencord/voltctl/internal/pkg/cli/version.Version=$(VERSION)\" \
35 -X \"github.com/opencord/voltctl/internal/pkg/cli/version.VcsRef=$(GITCOMMIT)\" \
36 -X \"github.com/opencord/voltctl/internal/pkg/cli/version.VcsDirty=$(GITDIRTY)\" \
37 -X \"github.com/opencord/voltctl/internal/pkg/cli/version.GoVersion=$(GOVERSION)\" \
38 -X \"github.com/opencord/voltctl/internal/pkg/cli/version.Os=$(HOST_OS)\" \
39 -X \"github.com/opencord/voltctl/internal/pkg/cli/version.Arch=$(HOST_ARCH)\" \
40 -X \"github.com/opencord/voltctl/internal/pkg/cli/version.BuildTime=$(BUILDTIME)\""
Zack Williamse940c7a2019-08-21 14:25:39 -070041
42# Release related items
43# Generates binaries in $RELEASE_DIR with name $RELEASE_NAME-$RELEASE_OS_ARCH
44# Inspired by: https://github.com/kubernetes/minikube/releases
45RELEASE_DIR ?= release
46RELEASE_NAME ?= voltctl
Ciprian Barbu72bdf892020-01-29 13:42:48 +020047RELEASE_OS_ARCH ?= linux-amd64 linux-arm64 windows-amd64 darwin-amd64
Zack Williamse940c7a2019-08-21 14:25:39 -070048
Kent Hagerman813cb902020-02-20 10:01:38 -050049# tool containers
David K. Bainbridge3e83a5b2021-04-09 16:18:04 +000050VOLTHA_TOOLS_VERSION ?= 2.4.0
Zack Williamse940c7a2019-08-21 14:25:39 -070051
Kent Hagerman813cb902020-02-20 10:01:38 -050052GO = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golang go
53GO_SH = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golang sh -c
54GO_JUNIT_REPORT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/appecho -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-go-junit-report go-junit-report
55GOCOVER_COBERTURA = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-gocover-cobertura gocover-cobertura
56GOLANGCI_LINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg -e GOGC=10 voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golangci-lint golangci-lint
Zack Williamse940c7a2019-08-21 14:25:39 -070057
Kent Hagerman813cb902020-02-20 10:01:38 -050058release:
59 @mkdir -p $(RELEASE_DIR)
60 @${GO_SH} ' \
61 set -e -o pipefail; \
62 for x in ${RELEASE_OS_ARCH}; do \
63 OUT_PATH="$(RELEASE_DIR)/$(RELEASE_NAME)-$(subst -dev,_dev,$(VERSION))-$$x"; \
64 echo "$$OUT_PATH"; \
65 GOOS=$${x%-*} GOARCH=$${x#*-} go build -mod=vendor -v $(LDFLAGS) -o "$$OUT_PATH" cmd/voltctl/voltctl.go; \
66 done'
divyadesaid3317312020-04-08 09:43:11 +000067## Local Development Helpers
68local-lib-go:
69ifdef LOCAL_LIB_GO
David K. Bainbridge1d946442021-03-19 16:45:52 +000070 rm -rf vendor/github.com/opencord/voltha-lib-go/v4/pkg
kesavand8ec4fc02021-01-27 09:10:22 -050071 mkdir -p vendor/github.com/opencord/voltha-lib-go/v4/pkg
72 cp -r ${LOCAL_LIB_GO}/pkg/* vendor/github.com/opencord/voltha-lib-go/v4/pkg/
divyadesaid3317312020-04-08 09:43:11 +000073endif
Zack Williamse940c7a2019-08-21 14:25:39 -070074
divyadesaid3317312020-04-08 09:43:11 +000075build: local-lib-go
David Bainbridge86971522019-09-26 22:09:39 +000076 go build -mod=vendor $(LDFLAGS) cmd/voltctl/voltctl.go
Zack Williamse940c7a2019-08-21 14:25:39 -070077
David Bainbridge86971522019-09-26 22:09:39 +000078install:
79 go install -mod=vendor $(LDFLAGS) cmd/voltctl/voltctl.go
Zack Williamse940c7a2019-08-21 14:25:39 -070080
David Bainbridge86971522019-09-26 22:09:39 +000081run:
82 go run -mod=vendor $(LDFLAGS) cmd/voltctl/voltctl.go $(CMD)
Zack Williamse940c7a2019-08-21 14:25:39 -070083
David Bainbridge12f036f2019-10-15 22:09:04 +000084lint-mod:
Scott Baker4a35a702019-11-26 08:17:33 -080085 @echo "Running dependency check..."
Kent Hagerman813cb902020-02-20 10:01:38 -050086 @${GO} mod verify
Scott Baker4a35a702019-11-26 08:17:33 -080087 @echo "Dependency check OK. Running vendor check..."
88 @git status > /dev/null
Kent Hagerman813cb902020-02-20 10:01:38 -050089 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && git status -- go.mod go.sum vendor && exit 1)
90 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && git status -- go.mod go.sum vendor && exit 1)
91 ${GO} mod tidy
92 ${GO} mod vendor
Scott Baker4a35a702019-11-26 08:17:33 -080093 @git status > /dev/null
Kent Hagerman813cb902020-02-20 10:01:38 -050094 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1)
95 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1)
Scott Baker4a35a702019-11-26 08:17:33 -080096 @echo "Vendor check OK."
David Bainbridge12f036f2019-10-15 22:09:04 +000097
Kent Hagerman813cb902020-02-20 10:01:38 -050098lint: lint-mod
David Bainbridge12f036f2019-10-15 22:09:04 +000099
David Bainbridge12f036f2019-10-15 22:09:04 +0000100sca:
David Bainbridge12f036f2019-10-15 22:09:04 +0000101 @rm -rf ./sca-report
102 @mkdir -p ./sca-report
Kent Hagerman813cb902020-02-20 10:01:38 -0500103 @echo "Running static code analysis..."
104 @${GOLANGCI_LINT} run --deadline=20m --out-format junit-xml ./... | tee ./sca-report/sca-report.xml
105 @echo ""
106 @echo "Static code analysis OK"
David Bainbridge86971522019-09-26 22:09:39 +0000107
108test:
Scott Baker2b0ad652019-08-21 14:57:07 -0700109 @mkdir -p ./tests/results
Kent Hagerman813cb902020-02-20 10:01:38 -0500110 @${GO} test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\
Scott Baker2b0ad652019-08-21 14:57:07 -0700111 RETURN=$$? ;\
Kent Hagerman813cb902020-02-20 10:01:38 -0500112 ${GO_JUNIT_REPORT} < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\
113 ${GOCOVER_COBERTURA} < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\
Scott Baker2b0ad652019-08-21 14:57:07 -0700114 exit $$RETURN
Zack Williamse940c7a2019-08-21 14:25:39 -0700115
116view-coverage:
David Bainbridge86971522019-09-26 22:09:39 +0000117 go tool cover -html ./tests/results/go-test-coverage.out
Zack Williamse940c7a2019-08-21 14:25:39 -0700118
David Bainbridge12f036f2019-10-15 22:09:04 +0000119check: lint sca test
120
Zack Williamse940c7a2019-08-21 14:25:39 -0700121clean:
David Bainbridge12f036f2019-10-15 22:09:04 +0000122 rm -rf voltctl voltctl.cp release sca-report
Kent Hagerman813cb902020-02-20 10:01:38 -0500123
124mod-update:
125 ${GO} mod tidy
126 ${GO} mod vendor